
#ifndef __ipx_h
#define __ipx_h

#define EXTERN extern
#include "kernel/makra.h"
#include "kernel/proc_pub.h"
#include "common/callnr.h"
#include "common/type.h"
#include "common/com.h"
#include "common/const.h"
#include "common/stat.h"
#include "systask/syst_pub.h"
#include "ipx/ipxmes.h"
#include <stdlib.h>
#undef EXTERN

/* Konstanty */
#define IPX_SOCK_PREF 0x7000
#define MAX_SOCK_BUF 10
#define MAX_BUFFERS 50
#define PACKET_DATA_LEN 546
#define PACKET_HEAD_LEN 30
#define PACKET_LEN (PACKET_HEAD_LEN + PACKET_DATA_LEN)
#define MAX_TOS_ELEMENT 10
#define ERR -1

extern message fs_msg;
extern message fs_repmsg;

/* Struktury */
typedef  struct {	unsigned int node_h16;
			unsigned long node_l32;} NODE_ADR;

typedef	char DATA_BUF[PACKET_DATA_LEN];

// vir_bytes => unsigned int

typedef struct {	unsigned int local_port;
			unsigned int remote_port;
			NODE_ADR remote_node;
			unsigned long remote_net;
			unsigned int device_num;
			int in_use_flag;
			unsigned int wait_proc;
			vir_bytes wait_data_len;
			unsigned int wait_segment;
			char*  wait_offset;
			int buffers[MAX_SOCK_BUF];
			int buf_start;
			int buf_len;} TOS_ELEMENT;

typedef struct {	unsigned int checksum;
			unsigned int length;
			char transport_control;
			char packet_type;
			unsigned long destination_network;
			NODE_ADR destination_node;
			unsigned int destination_socket;
			unsigned long source_network;
			NODE_ADR source_node;
			unsigned int source_socket;
			DATA_BUF data;} IPX_PACKET;


typedef struct {	int next;
			int len;
			DATA_BUF buf;} IPX_BUF;

/* Funkce */
PUBLIC int ipx_init(void);
PUBLIC int ipx_do_socket(void);
PUBLIC int ipx_do_close(void);
PUBLIC int ipx_do_read(void);
PUBLIC int ipx_do_write(void);
PUBLIC int ipx_do_notify(void);
PUBLIC void ipx_set_lnet(void);
PUBLIC void ipx_set_lnode(void);
PUBLIC void ipx_set_gateway(void);

#endif