
#include "ipx/ipx.h"
#include "ipx/read.h"
#include "common/errno.h"

#define EXTERN
#include "fs/inode/read.h"
#include "fs/common/fsmes.h"
#undef EXTERN

PUBLIC int ipx_do_read(void) {

	int buf_index;			// Cislo bufferu s daty.
	int copy_len;			// Pocet bytu ktere se prenesou k uzivateli.
	int result;			// Pocet skutecne zkopirovanych bytu.
	int fd_index;			// Index do tabulky soketu (TOS).

// 1. desifrovani zpravy

	fd_index = fs_msg.ipx_rw_fd - IPX_SOCK_PREF;

// 2. zjistime jestli mame data a fd

	if (ipx_tos[fd_index].in_use_flag == FALSE) {
		fs_repmsg.ipx_rw_fd = EIPXSOCK;
		return EIPXSOCK;
	}

	if (ipx_tos[fd_index].buf_len == 0) {

// 2a. NEmame data - nastavime dont_reply
		ipx_tos[fd_index].wait_proc = who;
		ipx_tos[fd_index].wait_data_len = fs_msg.ipx_rw_nbytes;
		ipx_tos[fd_index].wait_segment = fs_msg.ipx_rw_segment;
		ipx_tos[fd_index].wait_offset = fs_msg.ipx_rw_offset;
		dont_reply = TRUE;
		return 0;
	}

/* 2b. ANO mame data -	zjistime kolik
				posleme data aplikaci (SYS_COPY)
				vycisteni bufferu */

	buf_index = ipx_tos[fd_index].buf_start;
	copy_len = min(buffers[buf_index].len, fs_msg.ipx_rw_nbytes);

/*PUBLIC int rw_user(int s, int u, char *vir, int bytes, char *buff, int direction)*/
/*Prenos dat mezi adr. prostorem (I/D) uzivatele a FS */
/*int s;			D or T space in user proc */
/*int u;			process # */
/*vir_bytes vir;		address within user space */
/*vir_bytes bytes;		# of bytes to transfer */
/*char *buff;			buffer in FS's space */
/*int direction;		TO_USER /FROM_USER */
/* Call the kernel to read and write user space */

	result = rw_user(fs_msg.ipx_rw_segment, who, fs_msg.ipx_rw_offset,
			 copy_len, buffers[buf_index].buf, TO_USER);
	if (result < 0) {
		fs_repmsg.ipx_rp_err = EIPXSOCK;
		return EIPXSOCK;
	}

	// uvolneni bufferu v socketu

	ipx_tos[fd_index].buf_start++;
	ipx_tos[fd_index].buf_start %= MAX_SOCK_BUF;
	ipx_tos[fd_index].buf_len--;

	// pridani do fronty volnych bufferu

 	buffers[buf_index].next = first_buf;
	first_buf = ipx_tos.buffers[buf_index];

return fs_repmsg.ipx_rp_nbytes = result;
}