
#include "ipx/ipx.h"
#include "ipx/write.h"
#include "common/errno.h"

#define EXTERN
#include "fs/inode/read.h"
#include "fs/common/fsmes.h"
#undef EXTERN


PUBLIC int ipx_do_write(void) {

	int copy_len;			// Pocet bytu ktere se prenesou k uzivateli.
	int result;			// Pocet skutecne zkopirovanych bytu.
	int fd_index;			// Index do tabulky soketu (TOS).

// 1. desifrovani zpravy

	fd_index = fs_msg.ipx_rw_fd - IPX_SOCK_PREF;

//2. zjistime jestli fd

	if (ipx_tos[fd_index].in_use_flag == FALSE) {
		fs_repmsg.ipx_rp_err = EIPXSOCK;
		return EIPXSOCK;
	}

//3. vytvoreni packetu

	packet.checksum = 0;
	packet.length = fs_msg.ipx_rw_nbytes;
	packet.transport_control = 0;
	packet.packet_type = 0;
	packet.destination_network = ipx_tos[fd_index].remote_net;
	packet.destination_node = ipx_tos[fd_index].remote_node;
	packet.destination_socket = ipx_tos[fd_index].remote_port;
	packet.source_network = local_net;
	packet.source_node = local_node;
	packet.source_socket = ipx_tos[fd_index].local_port;

/*PUBLIC int rw_user(int s, int u, char *vir, int bytes, char *buff, int direction)*/
/*Prenos dat mezi adr. prostorem (I/D) uzivatele a FS */
/*int s;			D or T space in user proc */
/*int u;			process # */
/*vir_bytes vir;		address within user space */
/*vir_bytes bytes;		# of bytes to transfer */
/*char *buff;			buffer in FS's space */
/*int direction;		TO_USER /FROM_USER */
/* Call the kernel to read and write user space */

	copy_len = min(PACKET_DATA_LEN, fs_msg.ipx_rw_nbytes);

	result = rw_user(fs_msg.ipx_rw_segment, who, fs_msg.ipx_rw_offset,
			 copy_len, packet.data, FROM_USER);

// Test jestli se podarilo data od uzivatele prevzit
	if (result < 0) {
		fs_repmsg.ipx_rp_err = EIPXSOCK;
		return EIPXSOCK;
	}

//4. odeslani packetu

	ipx_msg.m_source = FS;
	ipx_msg.m_type = C_WRITE;
	ipx_msg.ntd_rw_usertask = FS;
	ipx_msg.ntd_rw_nbytes = copy_len + PACKET_HEAD_LEN;
	if (packet.destination_network == local_net || packet.destination_network == 0) {
		ipx_msg.ntd_rw_nodeh = packet.destination_node.node_h16;
		ipx_msg.ntd_rw_nodel = packet.destination_node.node_l32;
	}
	else {	ipx_msg.ntd_rw_nodeh = gateway.node_h16;
		ipx_msg.ntd_rw_nodel = gateway.node_l32;
	}	
	ipx_msg.ntd_rw_segment = D;
	ipx_msg.ntd_rw_offset = (char*) &packet;

	send_recv(netdrv_task,ipx_msg);
	fs_repmsg.ipx_rp_nbytes = copy_len;

return copy_len;
}